// treedump.h
#include <stdio.h>
#include <string.h>
#include <dirent.h>
//void treedump(char *basePath, const int root, int WindowsFlag);
//int main(int argc, char **argv)
//{
//  char name[4096];
//  //printf("Enter path to list files: ");
//  //scanf("%s", name);
//  if (argc == 1) strcpy(name, "."); // default : current directory
//  else strcpy(name, argv[1]);
//  if ( name[strlen(name)-1] == ':' || name[strlen(name)-1] == '/' || name[strlen(name)-1] == '\\' ) {
//      name[strlen(name)] = '.';
//      name[strlen(name)+1] = 0;
//  }
//  treedump(name, 0, 0); // name should not end with ':', '/' or '\', if so then postfix the path with '.', (not 0) for Windows
//  //treedump(name, 0, !0); // name should not end with ':', '/' or '\', if so then postfix the path with '.', (not 0) for Windows
//  return 0;
//}

// (not 0) for Windows i.e. treedump(name, 0, !0)
void treedump(char *basePath, const int root, int WindowsFlag, long long *Entries) {
    char path[4096];
    struct dirent *dp;
    DIR *dir;// = opendir(basePath);
    int i;

        dir = opendir(basePath);
    if (!dir) return;
    while ((dp = readdir(dir)) != NULL) {
        if (strcmp(dp->d_name, ".") != 0 && strcmp(dp->d_name, "..") != 0) {
/*
            for (i=0; i<root; i++) {
                if (i%2 == 0) printf("%c", 179);
                else printf(" ");
            }
            printf("%c%c%s\n", 195, 196, dp->d_name);
*/
//          printf("%s\n", dp->d_name);
            strcpy(path, basePath);
            if (WindowsFlag) strcat(path, "\\");
            else strcat(path, "/");
            strcat(path, dp->d_name);
            //printf("%s\n", path);
                        *Entries=*Entries+1;
            treedump(path, root + 2, WindowsFlag, Entries);
        }
    }
    closedir(dir);
        return;
}

// 'PoolToHousePathS_REALsize' serves as function exit value - if 0 then POOL is not filled somehow, probably due to overflow
// 'PoolToHousePathS_REALsize' should be 0 at entry
void treedumpPOOL(char *basePath, const int root, int WindowsFlag, long long *Entries, char *PoolToHousePathS, long long *PoolToHousePathS_MAXsize, long long *PoolToHousePathS_REALsize) {
    char path[4096];
    struct dirent *dp;
    DIR *dir;// = opendir(basePath);
    int i;

        dir = opendir(basePath);
    if (!dir) return;
    while ((dp = readdir(dir)) != NULL) {
        if (strcmp(dp->d_name, ".") != 0 && strcmp(dp->d_name, "..") != 0) {
/*
            for (i=0; i<root; i++) {
                if (i%2 == 0) printf("%c", 179);
                else printf(" ");
            }
            printf("%c%c%s\n", 195, 196, dp->d_name);
*/
//          printf("%s\n", dp->d_name);
            strcpy(path, basePath);
            if (WindowsFlag) strcat(path, "\\");
            else strcat(path, "/");
            strcat(path, dp->d_name);
            //printf("%s\n", path); //This goes to console
                        if ( (*PoolToHousePathS_REALsize + strlen(path))+1 < *PoolToHousePathS_MAXsize ) {
                                memcpy(PoolToHousePathS+*PoolToHousePathS_REALsize, path, strlen(path)+1); //+1 to make it ASCIIZ
                                *PoolToHousePathS_REALsize = *PoolToHousePathS_REALsize + strlen(path)+1;
                        } else {
                                *PoolToHousePathS_REALsize=0;
                                return;
                        }
                        *Entries=*Entries+1;
            treedumpPOOL(path, root + 2, WindowsFlag, Entries, PoolToHousePathS, PoolToHousePathS_MAXsize, PoolToHousePathS_REALsize);
}
    }
    closedir(dir);
        return;
}
